//uniform sampler2D Texture0; // light remaining map
uniform sampler2D Texture1; // alpha and diffuse map
//uniform sampler2D Texture2; // normal/specular map
//uniform sampler2D Texture3; // light1/2 visibility - luminance+alpha

uniform lowp vec3 U_FogCol;

varying lowp vec3 PS_AdjColour;
varying lowp vec3 PS_AdjFogCol;
varying mediump vec2 PS_TexCoord0;

void main(void)
{
    lowp vec4 textureCol = texture2D(Texture1, PS_TexCoord0);
    
    if (textureCol.a < 0.4)
        discard;
    
    /*
    // not gamma correct
    lowp vec3 colour = PS_Colour*textureCol.rgb;
    gl_FragColor.rgb = mix(colour, U_FogCol, PS_FogFactor);
    
    //gl_FragColor.rgb  = PS_Colour;
    */
    
    gl_FragColor.rgb = PS_AdjFogCol + PS_AdjColour*textureCol.rgb;
}
