//uniform sampler2D Texture4; // env map
//uniform sampler2D Texture5; // env visibility

uniform mat4 PTransform;
uniform mat4 MVTransform;
uniform float U_FogDist;
uniform lowp vec3 U_FogCol;

//attribute vec4 VS_EnvVisibility; // removed as tab doesn't allow this many vertex attributes
attribute vec4 VS_Position;
attribute vec3 VS_Colour;
attribute vec2 VS_TexCoord0;

varying lowp vec4 PS_AdjColour;
varying lowp vec4 PS_AdjFogCol;
varying vec2 PS_TexCoord0;

void main(void)
{
    vec4 pos = MVTransform * VS_Position;
    gl_Position = PTransform*pos;
    float dist = length(pos.xyz);
    
    /*
    gl_Position = PTransform * MVTransform * VS_Position;
    
    vec3 MVPosition = (MVTransform * VS_Position).xyz;
    
    float dist = length(MVPosition);
    */
     
    PS_TexCoord0 = VS_TexCoord0*2.0;
    
    //PS_Colour = (max(VS_Light1Dir.z, 0.0)*VS_Light1Col) + (max(VS_Light2Dir.z, 0.0)*VS_Light2Col) + VS_RemainingCol - 0.25;
    //PS_Colour = vec3(0.0,0.0,0.0);
    //PS_Colour = VS_Colour;
    
    float fogFactor = clamp(dist/U_FogDist, 0.0, 1.0); // was /9000.0
    
    PS_AdjColour.rgb = VS_Colour*(1.0 - fogFactor);
    PS_AdjFogCol.rgb = U_FogCol*fogFactor;
    
    PS_AdjColour.a = 1.0;
    PS_AdjFogCol.a = 0.0;
    
    // removed as many android devices don't support texture2d lookups in vertex shader
    //vec2 skyVisMapBase = (floor(PS_TexCoord0*64.0)+0.5)/64.0; // could avoid this by passing in more params, but this is slower
    //vec4 diffuseVisMap = texture2D(Texture5, skyVisMapBase); // will be a fixed value
    //vec2 diffuseEnvCoords = vec2(0.0244,0.0244);
    //vec3 diffuseReflection = texture2D(Texture4, diffuseEnvCoords).rgb; // will be a fixed value
    //float diffuseVis = dot(diffuseVisMap, VS_EnvVisibility);
    //PS_Colour += mix(vec3(0.06,0.06,0.06), diffuseReflection, diffuseVis);
    
    //PS_FogFactor = clamp(dist/U_FogDist, 0.0, 1.0); // was /9000.0
}
