uniform sampler2D Texture0; // light remaining map
uniform sampler2D Texture1; // alpha and diffuse map
//uniform sampler2D Texture2; // normal/specular map
uniform sampler2D Texture3; // light1/2 visibility - luminance+alpha

uniform lowp vec3 U_FogCol;

varying lowp vec3 PS_Light1Col;
varying lowp vec3 PS_Light2Col;
varying lowp vec3 PS_Colour;
varying lowp float PS_FogFactor;
varying mediump vec2 PS_TexCoord0;
varying mediump vec2 PS_TexCoord1;

void main(void)
{
    lowp float light1Vis = texture2D(Texture3, PS_TexCoord0).r;
    lowp float light2Vis = texture2D(Texture3, PS_TexCoord0).a;
    lowp vec4 textureCol = texture2D(Texture1, PS_TexCoord1);
    lowp vec3 remainingCol = texture2D(Texture0, PS_TexCoord0).rgb;
    
    // not gamma correct
    lowp vec3 colour = (PS_Colour+(light1Vis*PS_Light1Col)+(light2Vis*PS_Light2Col)+remainingCol)*textureCol.rgb;
    gl_FragColor.rgb = mix(colour, U_FogCol, PS_FogFactor);
    gl_FragColor.a = textureCol.a;
}
