//uniform sampler2D Texture4; // env map
//uniform sampler2D Texture5; // env visibility

uniform mat4 PTransform;
uniform mat4 MVTransform;
uniform float U_FogDist;

//attribute vec4 VS_EnvVisibility; // removed as tab doesn't allow this many vertex attributes
attribute vec4 VS_Position;
attribute vec3 VS_Light1Dir;
attribute vec3 VS_Light2Dir;
attribute vec3 VS_Light1Col;
attribute vec3 VS_Light2Col;
attribute vec3 VS_Colour;
attribute vec2 VS_TexCoord0;
attribute vec2 VS_TexCoord1;

varying vec3 PS_Light1Col;
varying vec3 PS_Light2Col;
varying vec3 PS_Colour;
//varying float PS_Light1Diffuse;
//varying float PS_Light2Diffuse;
varying float PS_FogFactor;
varying vec2 PS_TexCoord0;
varying vec2 PS_TexCoord1;

void main(void)
{
    PS_Colour = VS_Colour*2.0; // scale should be game-side
    PS_Colour -= 0.25;
    gl_Position = PTransform * MVTransform * VS_Position;
    
    //vec3 normal_cameraSpace = normalize(vec3(MVTransform * vec4(VS_Normal, 0.0)));
    //vec3 tangent_cameraSpace = normalize(vec3(MVTransform * vec4(VS_Tangent, 0.0)));
    //vec3 bitan_cameraSpace = normalize(vec3(MVTransform * vec4(VS_Bitan, 0.0)));
    //mat3 tsprotation = mat3(tangent_cameraSpace.x, bitan_cameraSpace.x, normal_cameraSpace.x,
    //                        tangent_cameraSpace.y, bitan_cameraSpace.y, normal_cameraSpace.y,
    //                        tangent_cameraSpace.z, bitan_cameraSpace.z, normal_cameraSpace.z);
    
    vec3 MVPosition = (MVTransform * VS_Position).xyz;
    
    float dist = length(MVPosition);
    
    //vec3 cameraDir = tsprotation * (MVPosition/dist);
    
    PS_TexCoord0 = VS_TexCoord0*2.0;
    PS_TexCoord1 = VS_TexCoord1*2.0;
    
    // removed as many android devices don't support texture2d lookups in vertex shader
    //vec2 skyVisMapBase = (floor(PS_TexCoord0*64.0)+0.5)/64.0; // could avoid this by passing in more params, but this is slower
    //vec4 diffuseVisMap = texture2D(Texture5, skyVisMapBase); // will be a fixed value
    //vec2 diffuseEnvCoords = vec2(0.0244,0.0244);
    //vec3 diffuseReflection = texture2D(Texture4, diffuseEnvCoords).rgb; // will be a fixed value
    //float diffuseVis = dot(diffuseVisMap, VS_EnvVisibility);
    //PS_Colour += mix(vec3(0.06,0.06,0.06), diffuseReflection, diffuseVis);
    
    PS_FogFactor = clamp(dist/U_FogDist, 0.0, 1.0); // was /9000.0
    
    //PS_Light1Diffuse = max(VS_Light1Dir.z, 0.0);
    //PS_Light2Diffuse = max(VS_Light2Dir.z, 0.0);
    
    PS_Light1Col = VS_Light1Col*max(VS_Light1Dir.z, 0.0);
    PS_Light2Col = VS_Light2Col*max(VS_Light2Dir.z, 0.0);
}
