uniform sampler2D Texture0; // alpha and diffuse map

uniform lowp vec3 U_FogCol;

varying lowp vec3 PS_Colour;
varying lowp float PS_FogFactor;
varying mediump vec2 PS_TexCoord0;

void main(void)
{
    lowp vec4 textureCol = texture2D(Texture0, PS_TexCoord0);
    
    gl_FragColor.a = textureCol.a;
    
    lowp vec3 colour = PS_Colour * textureCol.rgb;
    gl_FragColor.rgb = mix(colour, U_FogCol, PS_FogFactor);
}
