//uniform sampler2D Texture4; // env map

uniform mat4 PTransform;
uniform mat4 MVTransform;
uniform vec3 U_SkyCol;
uniform float U_FogDist;

attribute vec4 VS_Position;
attribute vec3 VS_Normal;
attribute vec4 VS_AmbientColour;
attribute vec4 VS_Light1Col;
attribute vec3 VS_Light1Dir;
attribute vec3 VS_Light2Col;
attribute vec3 VS_Light2Dir;
attribute vec2 VS_TexCoord0;

//varying vec3 PS_ReflectDir;
//varying vec3 PS_Light1Dir;
//varying vec4 PS_Light1Col;
//varying vec3 PS_Light2Dir;
//varying vec3 PS_Light2Col;
varying float PS_FogFactor;
varying vec3 PS_Colour;
varying vec2 PS_TexCoord0;
//varying vec2 PS_TexCoord1;
 
void main(void)
{
    //mediump vec2 diffuseEnvCoords = 0.0244 + VS_Normal.xy*0.0244;
    //lowp vec3 diffuseReflection = texture2D(Texture4, diffuseEnvCoords).rgb;
    
    vec3 MVPosition = (MVTransform * VS_Position).xyz;
    float dist = length(MVPosition);
    //PS_AmbientColour = VS_AmbientColour;
    gl_Position = PTransform * MVTransform * VS_Position;
    
    //vec3 cameraDir = MVPosition/dist;
    
    //lowp float fresnel = dot(cameraDir, VS_Normal);
    //PS_ReflectDir = cameraDir - 1.999*fresnel*VS_Normal;
    //PS_TexCoord1 = 0.5 + PS_ReflectDir.xy*0.5;
    
    lowp float skyThreshold = VS_Light1Col.a;
    lowp float diffuseVis = smoothstep(skyThreshold-0.3, skyThreshold+0.3, VS_Normal.y);
    
    //diffuseReflection = mix(vec3(0.12,0.12,0.12), diffuseReflection, diffuseVis); // brighter to account for being higher, so see more floor, and floor is generally brighter than walls
    lowp vec3 diffuseReflection = mix(vec3(0.12,0.12,0.12), U_SkyCol, diffuseVis); // brighter to account for being higher, so see more floor, and floor is generally brighter than walls
    
    lowp float diff1 = max(dot(VS_Normal, VS_Light1Dir), 0.0);
    lowp float diff2 = max(dot(VS_Normal, VS_Light2Dir), 0.0);
    lowp vec3 diffuse = diff1*VS_Light1Col.rgb + diff2*VS_Light2Col;
    
    PS_Colour = VS_AmbientColour.rgb + diffuseReflection + diffuse - 0.15; // should be -0.25, but 0.15 looks better
    
    //PS_Normal = VS_Normal;
    PS_TexCoord0 = VS_TexCoord0*2.0;
    //PS_Light1Col = VS_Light1Col;
    //PS_Light1Dir = VS_Light1Dir;
    //PS_Light2Col = VS_Light2Col;
    //PS_Light2Dir = VS_Light2Dir;
    
    PS_FogFactor = clamp(dist/U_FogDist, 0.0, 1.0); // was /9000.0
}
