uniform sampler2D Texture0;

uniform lowp vec3 U_FogCol;

varying lowp vec4 PS_Colour;
varying lowp vec2 PS_TexCoord0;
varying lowp float PS_FogFactor;

void main(void)
{
    lowp vec4 textureCol = texture2D(Texture0, PS_TexCoord0);
    if (textureCol.a < 0.4)
        discard; // bad on pvr, but only way to solve alpha sorting problems
    
    lowp vec3 colour = PS_Colour.rgb * textureCol.rgb;
    gl_FragColor.rgb = mix(colour, U_FogCol, PS_FogFactor);
    gl_FragColor.a = PS_Colour.a;
}