uniform mat4 PTransform;
uniform mat4 MVTransform;
uniform float U_FogDist;

attribute vec4 VS_Position;
attribute vec4 VS_Colour;
attribute vec2 VS_TexCoord0;
 
varying vec4 PS_Colour;
varying vec2 PS_TexCoord0;
varying float PS_FogFactor;
 
void main(void)
{
    vec3 MVPosition = (MVTransform * VS_Position).xyz;
    float dist = length(MVPosition);
    gl_Position = PTransform * MVTransform * VS_Position;
    PS_TexCoord0 = VS_TexCoord0*2.0;
    PS_FogFactor = clamp(dist/U_FogDist, 0.0, 1.0); // was /9000.0
    PS_Colour.rgb = VS_Colour.rgb;
    PS_Colour.a = VS_Colour.a;
}
