uniform sampler2D Texture_Diffuse;

uniform lowp vec3 U_FogCol;

varying mediump vec2 PS_TexCoord;
varying lowp vec3 PS_DiffuseCol;
varying lowp float PS_FogFactor;

void main(void)
{
    lowp vec4 textureCol = texture2D(Texture_Diffuse, PS_TexCoord);
    if (textureCol.a < 0.4)
        discard; // bad on pvr, but only way to solve alpha sorting problems
    
    lowp vec3 colour = PS_DiffuseCol * textureCol.rgb;
    gl_FragColor.rgb = mix(colour, U_FogCol, PS_FogFactor);
}
