uniform mat4 PTransform;
uniform mat4 MVTransform;
uniform float U_FogDist;

attribute vec4 VS_Position;
attribute vec4 VS_Colour;
attribute vec2 VS_TexCoord0;
 
varying vec3 PS_Colour;
varying vec2 PS_TexCoord0;
 
void main(void)
{
    vec3 MVPosition = (MVTransform * VS_Position).xyz;
    float dist = length(MVPosition);
    gl_Position = PTransform * MVTransform * VS_Position;
    PS_TexCoord0 = VS_TexCoord0*2.0;
    float fogFactor = 1.0-clamp(dist/U_FogDist, 0.0, 1.0); // was /9000.0
    PS_Colour = VS_Colour.rgb*(1.3*fogFactor);
}
