uniform sampler2D Texture0;
uniform sampler2D Texture1;
uniform mediump vec2 TextureFract;

varying mediump float PS_Intensity;
varying lowp vec2 PS_TexCoord0;

void main(void)
{
    mediump vec2 distortOffset = texture2D(Texture0, PS_TexCoord0).rg;
    mediump vec2 texCoord = vec2(gl_FragCoord.x, gl_FragCoord.y);
    texCoord += (distortOffset*2.0-1.0)*PS_Intensity;
    texCoord *= TextureFract;
    // should take into account aspect ratio/pixel density etc.
    lowp vec3 screenColour = texture2D(Texture1, texCoord).rgb;
    
    //gl_FragColor.a = 1.0;
    gl_FragColor.rgb = screenColour;
}