uniform sampler2D SourceTex;
uniform sampler2D DirtTex;
uniform sampler2D CRTTex;

varying lowp vec2 PS_SourceTexCoord;
varying lowp vec2 PS_DirtTexCoord;
varying mediump vec2 PS_CRTTexCoord;
varying lowp vec4 PS_SourceColour;
varying lowp vec3 PS_DirtColour;

void main(void)
{
    lowp vec3 sourceCol = texture2D(SourceTex, PS_SourceTexCoord).rgb;
    lowp vec3 dirtCol = texture2D(DirtTex, PS_DirtTexCoord).rgb;
    lowp vec3 crtCol = texture2D(CRTTex, PS_CRTTexCoord).rgb;
    
    lowp vec3 newCol = PS_SourceColour.rgb * (sourceCol + (PS_DirtColour*dirtCol));
    
    // just dimmer
    //lowp vec3 menuCol = newCol*0.9;
    
    // orange/blue
    lowp vec3 menuCol = vec3(newCol.r, (newCol.r+newCol.b)*0.5, newCol.b);
    
    // green effect
    //lowp float grey = newCol.r*0.25 + newCol.g*0.5 + newCol.b*0.13;
    //lowp vec3 menuCol = vec3(grey*0.25, grey, grey*0.45);
    
    // cyan effect
    //lowp float grey = newCol.r*0.25 + newCol.g*0.5 + newCol.b*0.13;
    //lowp vec3 menuCol = vec3(grey*0.1, grey*0.9, grey);
    
    // orange effect
    //lowp float grey = newCol.r*0.25 + newCol.g*0.5 + newCol.b*0.13;
    //lowp vec3 menuCol = vec3(grey, grey*0.75, grey*0.25);
    
    // add crt effect
    menuCol *= crtCol;
    
    menuCol = min(vec3(0.5,0.5,0.5), menuCol);
    
    gl_FragColor.rgb = mix(newCol, menuCol, PS_SourceColour.a);
}
