uniform mat4 PTransform;
uniform mat4 MVTransform;

attribute vec4 VS_Position;
attribute vec2 VS_SourceTexCoord;
attribute vec2 VS_DirtTexCoord;
attribute vec4 VS_SourceColour;
attribute vec3 VS_DirtColour;

varying vec2 PS_SourceTexCoord;
varying vec2 PS_DirtTexCoord;
varying vec2 PS_CRTTexCoord;
varying vec4 PS_SourceColour;
varying vec3 PS_DirtColour;

 
void main(void)
{
    PS_SourceColour.rgb = VS_SourceColour.rgb*2.0;
    PS_SourceColour.a = VS_SourceColour.a;
    PS_DirtColour = VS_DirtColour*2.0;
    gl_Position = PTransform * MVTransform * VS_Position;
    PS_SourceTexCoord = VS_SourceTexCoord*2.0;
    PS_DirtTexCoord = VS_DirtTexCoord*2.0;
    PS_CRTTexCoord.s = VS_DirtTexCoord.s*80.0;
    PS_CRTTexCoord.t = VS_DirtTexCoord.t*50.0;
}
