uniform sampler2D SourceTex;
uniform sampler2D DirtTex;

varying lowp vec2 PS_SourceTexCoord;
varying lowp vec2 PS_DirtTexCoord;
varying lowp vec3 PS_SourceColour;
varying lowp vec3 PS_DirtColour;

void main(void)
{
    lowp vec3 sourceCol = texture2D(SourceTex, PS_SourceTexCoord).rgb;
    lowp vec3 dirtCol = texture2D(DirtTex, PS_DirtTexCoord).rgb;
    
    gl_FragColor.rgb = PS_SourceColour * (sourceCol + (PS_DirtColour*dirtCol));
    
    /*
    // orange-blue colour grading
    lowp vec3 colour = PS_SourceColour * (sourceCol + (PS_DirtColour*dirtCol));
    lowp vec3 finalColour;
    
    finalColour.r = colour.r*0.9 + colour.g*0.1;
    finalColour.g = colour.r*0.25 + colour.g*0.5 + colour.b*0.25;
    finalColour.b = colour.g*0.1 + colour.b*0.9;
    
    gl_FragColor.rgb = finalColour;
     */
}
